-#!/usr/bin/perl
+#!/usr/bin/env perl
=head1 NAME
-mr - a Multiple Repository management tool
+mr - a tool to manage all your version control repos
=head1 SYNOPSIS
B<mr> [options] log
+B<mr> [options] grep pattern
+
B<mr> [options] run command [param ...]
-B<mr> [options] bootstrap url [directory]
+B<mr> [options] bootstrap src [directory]
B<mr> [options] register [repository]
=head1 DESCRIPTION
-B<mr> is a Multiple Repository management tool. It can checkout, update, or
-perform other actions on a set of repositories as if they were one combined
-repository. It supports any combination of subversion, git, cvs, mercurial,
-bzr, darcs, fossil and veracity repositories, and support for other version
-control systems can easily be added.
+B<mr> is a tool to manage all your version control repos. It can checkout,
+update, or perform other actions on a set of repositories as if they were
+one combined repository. It supports any combination of subversion, git,
+cvs, mercurial, bzr, darcs, fossil and veracity repositories, and support
+for other version control systems can easily be added.
B<mr> cds into and operates on all registered repositories at or below your
working directory. Or, if you are in a subdirectory of a repository that
Show the commit log.
+=item grep pattern
+
+Searches for a pattern in each repository using the grep subcommand. Uses
+ack-grep on VCS that do not have their own.
+
=item run command [param ...]
Runs the specified command in each repository.
=over 4
-=item bootstrap url [directory]
+=item bootstrap src [directory]
+
+Causes mr to retrieve the source C<src> and use it as a .mrconfig file to
+checkout the repositories listed in it, into the specified directory.
+
+B<mr> understands several types of sources:
+
+=over 4
+
+=item URL for curl
-Causes mr to download the url, and use it as a .mrconfig file to checkout
-the repositories listed in it, into the specified directory.
+C<src> may be an URL understood by B<curl>.
-To use scp to download, the url may have the form ssh://[user@]host:file
+=item copy via ssh
+
+To use B<scp> to download, the C<src> may have the form
+C<ssh://[user@]host:file>.
+
+=item local file
+
+You can retrieve the config file by other means and pass its B<path> as C<src>.
+
+=item standard input
+
+If source C<src> consists in a single dash C<->, config file is read from
+standard input.
+
+=back
The directory will be created if it does not exist. If no directory is
specified, the current directory will be used.
-If the .mrconfig file includes a repository named ".", that
+As a special case, if source C<src> includes a repository named ".", that
is checked out into the top of the specified directory.
=item list (or ls)
Licensed under the GNU GPL version 2 or higher.
-http://kitenet.net/~joey/code/mr/
+http://myrepos.branchable.com/
=cut
sub loadconfig {
my $f=shift;
my $dir=shift;
- my $bootstrap_url=shift;
+ my $bootstrap_src=shift;
my @toload;
my $trusterror = sub {
my $msg=shift;
- if (defined $bootstrap_url) {
- die "mr: $msg in untrusted $bootstrap_url line $lineno\n".
+ if (defined $bootstrap_src) {
+ die "mr: $msg in untrusted $bootstrap_src line $lineno\n".
"(To trust this url, --trust-all can be used; but please use caution;\n".
"this can allow arbitrary code execution!)\n";
}
while (@lines) {
$_=$nextline->();
+ next if /^\s*\#/ || /^\s*$/;
+
if (! $trusted && /[[:cntrl:]]/) {
$trusterror->("illegal control character");
}
- next if /^\s*\#/ || /^\s*$/;
if (/^\[([^\]]*)\]\s*$/) {
$section=$1;
my $action=shift;
# actions that do not operate on all repos
- if ($action eq 'help') {
- help(@ARGV);
- }
- elsif ($action eq 'config') {
+ if ($action eq 'config') {
config(@ARGV);
}
elsif ($action eq 'register') {
}
sub help {
- exec($config{''}{DEFAULT}{help}) || die "exec: $!";
+ my $help=q#
+ case `uname -s` in
+ SunOS)
+ SHOWMANFILE="man -f"
+ ;;
+ Darwin)
+ SHOWMANFILE="man"
+ ;;
+ *)
+ SHOWMANFILE="man"
+ ;;
+ esac
+ if [ ! -e "$MR_PATH" ]; then
+ error "cannot find program path"
+ fi
+ tmp=$(mktemp -t mr.XXXXXXXXXX) || error "mktemp failed"
+ trap "rm -f $tmp" exit
+ pod2man -c mr "$MR_PATH" > "$tmp" || error "pod2man failed"
+ $SHOWMANFILE "$tmp" || error "man failed"
+ #;
+ exec($help) || die "exec: $!";
}
sub config {
}
sub bootstrap {
- my $url=shift @ARGV;
+ eval q{use File::Copy};
+ die $@ if $@;
+
+ my $src=shift @ARGV;
my $dir=shift @ARGV || ".";
- if (! defined $url || ! length $url) {
- die "mr: bootstrap requires url\n";
+ if (! defined $src || ! length $src) {
+ die "mr: bootstrap requires source\n";
}
-
- # Download the config file to a temporary location.
+
+ # Retrieve config file.
eval q{use File::Temp};
die $@ if $@;
my $tmpconfig=File::Temp->new();
- my @downloader;
- if ($url =~ m!^ssh://(.*)!) {
- @downloader = ("scp", $1, $tmpconfig);
+ if ($src =~ m!^[\w\d]+://!) {
+ # Download the config file to a temporary location.
+ my @downloader;
+ if ($src =~ m!^ssh://(.*)!) {
+ @downloader = ("scp", $1, $tmpconfig);
+ }
+ else {
+ @downloader = ("curl", "-A", "mr", "-L", "-s", $src, "-o", $tmpconfig);
+ push(@downloader, "-k") if $insecure;
+ }
+ my $status = system(@downloader);
+ die "mr bootstrap: invalid SSL certificate for $src (consider -k)\n"
+ if $downloader[0] eq 'curl' && $status >> 8 == 60;
+ die "mr bootstrap: download of $src failed\n" if $status != 0;
+ }
+ elsif ($src eq '-') {
+ # Config file is read from stdin.
+ copy(\*STDIN, $tmpconfig) || die "stdin: $!";
}
else {
- @downloader = ("curl", "-A", "mr", "-L", "-s", $url, "-o", $tmpconfig);
- push(@downloader, "-k") if $insecure;
+ # Config file is local.
+ die "mr bootstrap: cannot read file '$src'"
+ unless -r $src;
+ copy($src, $tmpconfig) || die "copy: $!";
}
- my $status = system(@downloader);
- die "mr bootstrap: invalid SSL certificate for $url (consider -k)\n"
- if $downloader[0] eq 'curl' && $status >> 8 == 60;
- die "mr bootstrap: download of $url failed\n" if $status != 0;
+ # Sanity check on destination directory.
if (! -e $dir) {
system("mkdir", "-p", $dir);
}
# would normally be skipped.
my $topdir=abs_path(".")."/";
my @repo=($topdir, $topdir, ".");
- loadconfig($tmpconfig, $topdir, $url);
+ loadconfig($tmpconfig, $topdir, $src);
record(\@repo, action("checkout", @repo, 1))
if exists $config{$topdir}{"."}{"checkout"};
if (-e ".mrconfig") {
- print STDERR "mr bootstrap: .mrconfig file already exists, not overwriting with $url\n";
+ print STDERR "mr bootstrap: .mrconfig file already exists, not overwriting with $src\n";
}
else {
- eval q{use File::Copy};
- die $@ if $@;
move($tmpconfig, ".mrconfig") || die "rename: $!";
}
sub main {
getopts();
init();
+ help(@ARGV) if $ARGV[0] eq 'help';
startingconfig();
loadconfig($HOME_MR_CONFIG);
svn_status = svn status "$@"
git_status = git status -s "$@" || true; git --no-pager log --branches --not --remotes --simplify-by-decoration --decorate --oneline || true
bzr_status = bzr status --short "$@"; bzr missing
-cvs_status = cvs status "$@"
+cvs_status = cvs -q status | grep -E '^(File:.*Status:|\?)' | grep -v 'Status: Up-to-date'
hg_status = hg status "$@"; hg summary --quiet | grep -v 'parent: 0:'
darcs_status = darcs whatsnew -ls "$@" || true
fossil_status = fossil changes "$@"
hg_trusted_checkout = hg clone $url $repo
darcs_trusted_checkout = darcs get $url $repo
git_bare_trusted_checkout = git clone --bare $url $repo
-vcsh_trusted_checkout = vcsh run "$MR_REPO" git clone $url $repo
+vcsh_old_trusted_checkout = vcsh run "$MR_REPO" git clone $url $repo
+vcsh_trusted_checkout = vcsh clone $url $repo
# fossil: messy to do
veracity_trusted_checkout = vv clone $url $repo
-help =
- case `uname -s` in
- SunOS)
- SHOWMANFILE="man -f"
- ;;
- Darwin)
- SHOWMANFILE="man"
- ;;
- *)
- SHOWMANFILE="man -l"
- ;;
- esac
- if [ ! -e "$MR_PATH" ]; then
- error "cannot find program path"
- fi
- tmp=$(mktemp -t mr.XXXXXXXXXX) || error "mktemp failed"
- trap "rm -f $tmp" exit
- pod2man -c mr "$MR_PATH" > "$tmp" || error "pod2man failed"
- $SHOWMANFILE "$tmp" || error "man failed"
list = true
config =
bootstrap =